main/urls.py
from django.urls import path
from . import views
app_name = "main"

urlpatterns = [
    path('', views.IndexView.as_view(), name="home"),
    path('contact/', views.ContactView.as_view(), name="contact"),
    path('portfolios/', views.PortfolioView.as_view(), name="portfolios"),
    path('portfolio/<slug:slug>', views.PortfolioDetailView.as_view(), name="portfolio"),
    path('blog/', views.BlogView.as_view(), name="blogs"),
    path('blog/<slug:slug>', views.BlogDetailView.as_view(), name="blog"),   
]

resume/urls.py
from xml.dom.minidom import Document
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls', namespace="main"))
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

main/models.py
from distutils.command.upload import upload
from email import message
from email.quoprimime import quote
from multiprocessing import AuthenticationError
from pyexpat import model
from signal import default_int_handler
from sqlite3 import Timestamp
from statistics import mode
from tabnanny import verbose
from tkinter import CASCADE
from tokenize import blank_re
from django.db import models
from django.contrib.auth.models import User
from django.template.defaultfilters import slugify
from ckeditor.fields import RichTextField
from django.core.validators import EmailValidator

class Skill(models.Model):
    class Meta:
        verbose_name_plural = 'Skills'
        verbose_name = 'Skill'

    name = models.CharField(max_length=80, blank=True)
    score = models.IntegerField(default=80, blank=True, null=True)
    image = models.FileField(blank=True, null=True, upload_to="skills")
    is_key_skill = models.BooleanField(default=False)
    is_coding_skill = models.BooleanField(default=False)

    def __str__(self):
        return self.name
    
class UserProfile(models.Model):

    class Meta:
        verbose_name_plural = 'User Profiles'
        verbose_name = 'User Profile'
    
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    avatar = models.ImageField(blank=True, null=True, upload_to="avatar")
    title = models.CharField(max_length=200, blank=True)
    bio = models.TextField(blank=True)
    skills = models.ManyToManyField(Skill, blank=True)
    cv = models.FileField(blank=True, null=True, upload_to="cv")

    def __str__(self):
        return f'{self.user.first_name} {self.user.last_name}'

class ContactProfile(models.Model):

    class Meta:
        verbose_name_plural = 'Contact Profiles'
        verbose_name = 'Contact Profile'
    
    timestamp = models.DateTimeField(auto_now_add=True)
    name = models.CharField(verbose_name="Name", max_length=100)
    email = models.EmailField(verbose_name="Email", validators=[EmailValidator()])
    message = models.TextField(verbose_name="Message")

    def __str__(self) -> str:
        return f'{self.name}'

class Testimonial(models.Model):

    class Meta:
        verbose_name_plural = 'Testimonials'
        verbose_name = 'Testimonial'
        ordering = ["name"]

    thumbnail = models.ImageField(blank=True, null=True, upload_to="testimonial")
    name = models.CharField(max_length=200, blank=True)
    role = models.CharField(max_length=200, blank=True)
    quote  = models.CharField(max_length=500, blank=True)
    is_active = models.BooleanField(default=True)

    def __str__(self):
        return self.name

class Media(models.Model):

    class Meta:
        verbose_name_plural = 'Media Files'
        verbose_name = 'Media File'
        ordering = ["name"]

    image = models.ImageField(blank=True, null=True, upload_to="media")
    url = models.URLField(blank=True, null=True)
    name = models.CharField(max_length=200, blank=True)
    is_image = models.BooleanField(default=True)

    def save(self, *args, **kwargs):
        if self.url:
            self.is_image = False
        super(Media, self).save(*args, **kwargs)
    def __str__(self):
        return self.name

class Portfolio(models.Model):

    class Meta:
        verbose_name_plural = 'Portfolio Profiles'
        verbose_name = 'Portfolio'
        ordering = ["name"]

    date = models.DateTimeField(blank=True, null=True)
    name = models.CharField(max_length=200, blank=True)
    description = models.CharField(max_length=500, blank=True)
    body = RichTextField(blank=True, null=True)
    image = models.ImageField(blank=True, null=True, upload_to="portfolio")
    slug = models.SlugField(blank=True, null=True)
    is_active = models.BooleanField(default=True)

    def save(self, *args, **kwargs):
        if not self.id:
            self.slug = slugify(self.name)
        super(Portfolio, self).save(*args, **kwargs)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return f"/portfolio/{self.slug}"

class Blog(models.Model):

    class Meta:
        verbose_name_plural = 'Blog Profiles'
        verbose_name = 'Blog'
        ordering = ['timestamp']

    timestamp = models.DateTimeField(auto_now_add=True)
    author = models.CharField(max_length=200, blank=True)
    name = models.CharField(max_length=200, blank=True)
    description = models.CharField(max_length=500, blank=True)
    body = RichTextField(blank=True, null=True)
    slug = models.SlugField(blank=True, null=True)
    image = models.ImageField(blank=True, null=True, upload_to="blog")
    is_active = models.BooleanField(default=True)

    def save(self, *args, **kwargs):
        if not self.id:
            self.slug = slugify(self.name)
        super(Blog, self).save(*args, **kwargs)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return f"/blog/{self.slug}"

class Certificate(models.Model):

    class Meta:
        verbose_name_plural = 'Certificates'
        verbose_name = 'Certificate'

    date = models.DateTimeField(blank=True, null=True)
    name = models.CharField(max_length=200, blank=True)
    title = models.CharField(max_length=200, blank=True)
    description = models.CharField(max_length=500, blank=True)
    is_active = models.BooleanField(default=True)

    def __str__(self):
        return self.name

main/forms.py
from email import message
from tabnanny import verbose
from django import forms
from .models import ContactProfile

class ContactForm(forms.ModelForm):

    class Meta:
        model   = ContactProfile
        fields = ('name', 'email', 'message')

    name = forms.CharField(max_length=100, required=True,
        widget=forms.TextInput(attrs={
            'placeholder': '*Full name..',
        }))
    email = forms.EmailField(max_length=254, required=True,
        widget=forms.TextInput(attrs={
            'placeholder': '*Email..',
         }))
    message = forms.CharField(max_length=1000, required=True,
        widget=forms.Textarea(attrs={
            'placeholder': '*Message..',
            'rows': 6,
        }))

main/views.py
from multiprocessing import context
from django.shortcuts import render
from django.contrib import messages
from .models import (
    UserProfile,
    Blog,
    Portfolio,
    Testimonial,
    Certificate,
    Skill
)
from django.views import generic
from . forms import ContactForm

class IndexView(generic.TemplateView):
    template_name = "main/index.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        coding_skills = Skill.objects.filter(is_coding_skill=True)
        testimonials = Testimonial.objects.filter(is_active=True)
        certificates = Certificate.objects.filter(is_active=True)
        blogs = Blog.objects.filter(is_active=True)
        portfolios = Portfolio.objects.filter(is_active=True)

        context["testimonials"] = testimonials
        context["certificates"] = certificates
        context["blogs"] = blogs
        context["portfolios"] = portfolios
        context["coding_skills"] = coding_skills
        return context

class ContactView(generic.FormView):
    template_name = "main/contact.html"
    form_class = ContactForm
    success_url = "/"

    def form_valid(self, form):
        form.save()
        messages.success(self.request, 'Thank you. We will be in touch soon.')
        return super().form_valid(form)
    
    def form_invalid(self, form):
        messages.error(self.request, 'Please fill in all the required fields correctly')
        return super().form_invalid(form)

class PortfolioView(generic.ListView):
    model = Portfolio
    template_name = "main/portfolio.html"
    paginate_by = 10
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        portfolios = Portfolio.objects.filter(is_active=True)
        context["portfolios"] = portfolios
        return context

    def get_queryset(self):
        return super().get_queryset().filter(is_active=True)
    
class PortfolioDetailView(generic.DetailView):
    model = Portfolio
    template_name = "main/portfolio-detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        portfolio = context['object']
        context["portfolio"] = portfolio
        return context
    

class BlogView(generic.ListView):
    model = Blog
    template_name = "main/blog.html"
    paginate_by = 10

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        blogs = Blog.objects.filter(is_active=True)
        context["blogs"] = blogs
        return context

    def get_queryset(self):
        return super().get_queryset().filter(is_active=True)

class BlogDetailView(generic.DetailView):
    model = Blog
    template_name = "main/blog-detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        blog = context['object']
        context["blog"] = blog
        return context
     

main/templates/main/base.html
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>{% block title %} {% endblock %}</title>
    <meta name="author" content="Resume">
    <link rel="canonical" href="{{request.path}}"/>
    <link rel="home" href="{% url 'main:home' %}"/>
    <meta name="description" content="{% block description %}{% endblock %}">
    <meta name="keywords" content="{% block keywords %}{% endblock %}">

    <link rel="shortcut icon" type="image/x-icon" href="{% static 'images/icon.jpg' %}">
    <link rel="apple-touch-icon" type="image/jpg" href="{% static 'images/icon.jpg' %}">

    <!-- ================================
    Start CSS
    ================================= -->
    <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">
    <link rel="stylesheet" href="https://unpkg.com/swiper@7.0.5/swiper-bundle.min.css">
    <link href="{% static 'css/style.css' %}" rel="stylesheet">
    {% block extends_header %}{% endblock %}
    <!-- ================================
    End CSS
    ================================= -->

  </head>
  <body>
    
    {% include 'main/partials/messages.html '%}

    {% include 'main/partials/nav.html'%}

    {% block content %}{% endblock %}
 
    {% include 'main/partials/footer.html' %}

    <!-- ================================
    Start Scripts
    ================================= -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="{% static 'js/bootstrap.bundle.min.js' %}"></script>
    <script src="https://unpkg.com/swiper@7.0.5/swiper-bundle.min.js"></script>
    <script src="{% static 'js/script.js' %}"></script>
    {% block extend_footer %}{% endblock %}
    <!-- ================================
    End Scripts
    ================================= -->
  </body>
</html>

main/templates/main/blog-detail.html
{% extends 'main/base.html' %}
{% load static %}

<!-- ================================
    Start SEO blocks
    ================================= -->
    {% block title %} {{portfolios.name}} {% endblock %}
    {% block description %}{% endblock %}
    {% block keywords %}{% endblock %}
<!-- ================================
    END SEO blocks
    ================================= -->
 
<!-- ================================
    Start CSS blocks
    ================================= -->
    {% block extends_header %}{% endblock %}
<!-- ================================
    END CSS blocks
    ================================= -->  
 
<!-- ================================
    Start Script blocks
    ================================= -->
    {% block extend_footer %}{% endblock %}
<!-- ================================
    END Script blocks
    ================================= -->  
    
    

<!-- ================================
    Start Content
    ================================= -->
    {% block  content %}
    <section>
      <div class="innerPageBannerCol">
        <div class="container">
          <div class="row g-4 g-md-3  align-items-center">
            <div class="col-md-6">
              <div class="bannerContent">
                <h1 class="xlTitle pb-md-3">{{blog.name}}</h1>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <section>
      <div class="lightBg">
        <div class="container p-5">
            <p>{{blog.name}}</p>
        </div>
      </div>
    </section>
    <!-- ================================
    End Content
    ================================= -->
    {% endblock %}

main/templates/main/blog.html
{% extends 'main/base.html' %}
{% load static %}

<!-- ================================
    Start SEO blocks
    ================================= -->
    {% block title %} Blogs {% endblock %}
    {% block description %}{% endblock %}
    {% block keywords %}{% endblock %}
<!-- ================================
    END SEO blocks
    ================================= -->
 
<!-- ================================
    Start CSS blocks
    ================================= -->
    {% block extends_header %}{% endblock %}
<!-- ================================
    END CSS blocks
    ================================= -->  
 
<!-- ================================
    Start Script blocks
    ================================= -->
    {% block extend_footer %}{% endblock %}
<!-- ================================
    END Script blocks
    ================================= -->  
    
    {% block  content %}
 
 <!-- ================================
    Start Content
    ================================= -->
    <section>
      <div class="innerPageBannerCol">
        <div class="container">
          <div class="row g-4 g-md-3  align-items-center">
            <div class="col-md-6">
              <div class="bannerContent">
                <h1 class="xlTitle pb-md-3">See my recent Blogs below</h1>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    
    <section>
      <div class="lightBg">
        <div class="container pt-4">
          <div class="row"> <!-- Add a row container -->
            {% for b in blogs %}
              {% if b.is_active %}
                <div class="col-md-6 pColMain mb-4"> <!-- Use col-md-6 to create two columns, and add mb-4 for space -->
                  <div class="pCol d-flex flex-column">
                    <div class="card rounded flex-grow-1">
                      <div class="card-body">
                        <a href = "{% url 'main:blog' slug=b.slug %}"><h5 class="card-title">{{ b.name }}</h5></a>
                        <p>{{b.body}}</p>
                      </div>
                    </div>
                  </div>
                </div>
              {% endif %}
            {% endfor %}
          </div>
        </div>
      </div>
    </section>
    
    {% endblock %}
    <!-- ================================
    End Content
    ================================= -->

main/templates/main/contact.html
{% extends 'main/base.html' %}
{% load static %}

<!-- ================================
    Start SEO blocks
    ================================= -->
    {% block title %} Contact {% endblock %}
    {% block description %}{% endblock %}
    {% block keywords %}{% endblock %}
<!-- ================================
    END SEO blocks
    ================================= -->
 
<!-- ================================
    Start CSS blocks
    ================================= -->
    {% block extends_header %}{% endblock %}
<!-- ================================
    END CSS blocks
    ================================= -->  
 
<!-- ================================
    Start Script blocks
    ================================= -->
    {% block extend_footer %}{% endblock %}
<!-- ================================
    END Script blocks
    ================================= -->  
    
    

<!-- ================================
    Start Content
    ================================= -->
    {% block  content %}
    <section>
      <div class="innerPageBannerCol">
        <div class="container">
          <div class="row g-4 g-md-3  align-items-center">
            <div class="col-md-6">
              <div class="bannerContent">
                <h1 class="xlTitle pb-md-3">Contact me below</h1>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <section>
      <div class="lightBg">
        <div class="container p-5">
            <form id="contactForm" method="POST" action="/contact/">
              {% csrf_token %}
                <label for="name">Name</label>
                {{form.name}}

                <label for="email">Email</label>
                {{form.email}}

                <label for="messages">Message</label>
                {{form.message}}
                
                <input class='btn btnPrimary' type="submit" value="Submit">
            </form>
        </div>
      </div>
    </section>
    <!-- ================================
    End Content
    ================================= -->
    {% endblock %}

main/templates/main/index.html
{% extends 'main/base.html' %}
{% load static %}

<!-- ================================
    Start SEO blocks
    ================================= -->
    {% block title %} Home {% endblock %}
    {% block description %}{% endblock %}
    {% block keywords %}{% endblock %}
<!-- ================================
    END SEO blocks
    ================================= -->
 
<!-- ================================
    Start CSS blocks
    ================================= -->
    {% block extends_header %}{% endblock %}
<!-- ================================
    END CSS blocks
    ================================= -->  
 
<!-- ================================
    Start Script blocks
    ================================= -->
    {% block extend_footer %}{% endblock %}
<!-- ================================
    END Script blocks
    ================================= -->  
    

<!-- ================================
    Start Content
    ================================= -->
    {% block content %}
    <section>
      <div class="bannerSection">
        <div class="container">
          <div class="row g-4 g-md-3  align-items-center">
            <div class="col-md-auto order-md-last">
              <div class="bannerUserImg">
                <img src="{{me.userprofile.avatar.url}}" alt="...">
              </div>
            </div>
            <div class="col-md">
              <div class="bannerContent">
                <h1 class="xlTitle pb-3">Hi, I’m {{me.first_name}}, <br> a {{me.userprofile.title}}r</h1>
                <p>{{me.userprofile.bio}}</p>
                <div class="bannerBtnCol">
                  <div class="row">
                    <div class="col-auto">
                      {% comment %} <a download href="{{me.userprofile.cv.url}}" class="btn btnPrimary">Download Resume</a> {% endcomment %}
                    </div>
                    <div class="col-auto">
                      <a href="{% url 'main:contact' %}" class="btn btnOutline">Contact</a>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
<!-- ==========================================
  Skill Blocks
 ============================================== -->
<!-- Skill still hard coded need to be updated -->
    <section>
      <div class="sectionSpace pt-0">
        <div class="container">
          <div class="row">
            <div class="col-md-auto">
              <div class="keySkillCol">
                <h4 class="smTitle pb-3">Key Skills</h4>
                <div class="keySkillCard">
                  <div class="ksIconCol">
                    <img src="{% static 'images/key-skill-icon-1.svg' %}" alt="...">
                  </div>
                  <span class="ksText">Key Skill 1</span>
                </div>
                <div class="keySkillCard">
                  <div class="ksIconCol">
                    <img src="{% static 'images/key-skill-icon-2.svg' %}" alt="...">
                  </div>
                  <span class="ksText">Key Skill 2</span>
                </div>
                <div class="keySkillCard">
                  <div class="ksIconCol">
                    <img src="{% static 'images/key-skill-icon-3.svg' %}" alt="...">
                  </div>
                  <span class="ksText">Key Skill 3</span>
                </div>
              </div>
            </div>
            <div class="col-md">
              <h4 class="smTitle pb-3">Coding Skills</h4>
              <div class="progressCol">
                <div class="progressCard">
                  {% for cs in coding_skills %}
                  <div class="progressCol">
                    <span class="progressLbl">{{cs.name}}</span>
                    <div class="row g-2 align-items-center">
                      <div class="col">
                        <div class="progress progressStyle">
                          <div class="progress-bar" role="progressbar" style="width: {{ cs.score }}%;" aria-valuenow="{{ cs.score }}" aria-valuemin="0" aria-valuemax="100"></div>
                        </div>
                      </div>
                      <div class="col-auto">
                        <span class="pLbl">{{cs.score}}%</span>
                      </div>
                    </div>
                  </div>
                  {% endfor %}
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section> 
<!-- ================================
    END Skill Blocks
    ================================= -->  
    <!-- ================================
    Start Certificates Blocks
    ================================= --> 
    <section>
      <div class="sectionSpaceSm lightBg">
        <div class="container">
          <div class="row pb-3">
            <div class="col">
              <h4 class="smText regular">Certificates</h4>
            </div>
          </div>
          <div class="sliderOuter">
            <div class="swiper certificatesSlider">
              <div class="swiper-wrapper">
                {% for c in certificates %}
                {% if c.is_active%}
                  <div class="swiper-slide">
                    <div class="cardStyle1">
                      <h4 class="mdTitle cs1Title">
                        <a href="javascript:void(0)">{{c.title}}</a>
                      </h4>
                      <ul class="cardOptionCol">
                        <li>{{c.date.date}}</li>
                        <li>{{c.name}}</li>
                      </ul>
                      <p>{{c.description}}</p>
                    </div>
                  </div>
                {% endif %}
                {% endfor %}

              </div>
            </div>            
            <div class="cert-swiper-button-next swiper-button-next swiperBtnStyle"></div>
            <div class="cert-swiper-button-prev swiper-button-prev swiperBtnStyle"></div>
            <div class="swiper-pagination swiperPaginationStyle posInitial"></div>
          </div>
        </div>
      </div>
    </section>
    <!-- ================================
    END Certificates Blocks
    ================================= --> 

    <!-- ================================
    Start Featured Work Blocks
    ================================= --> 
    <section>
      <div class="sectionSpace">
        <div class="container">
          <div class="portfolioCol">
            <div class="row pb-3">
              <div class="col">
                <h4 class="smText regular">Featured Work</h4>
              </div>
              <div class="col-auto">
                <a href="{% url 'main:portfolios'%}" class="simpleLink">View all</a>
              </div>
            </div>
            {% for p in portfolios|dictsortreversed:"date"|slice:":3" %}
            {% if p.is_active %}
            <div class="portfolioCard">
              <div class="row g-4 align-items-center">
                <div class="col-md-auto">
                  <div class="portfolioImgCol">
                    <a href="{% url 'main:portfolio' slug=p.slug %}"><img src="{{ p.image.url }}" alt="..."></a>
                  </div>
                </div>
                <div class="col-md">
                  <div class="portfolioContentCol">
                    <h4 class="lgTitle"><a href="{% url 'main:portfolio' slug=p.slug %}">{{p.name}}</a></h4>
                    <ul class="portfolioOption">
                      <li><span class="dateLbl">{{p.date|date:"F d, Y"}}</span></li>
                    </ul>
                    <p>{{p.description}}</p>
                  </div>
                </div>
              </div>
            </div>
            {% endif %}
            {% endfor %}
          </div>
          <!-- ================================
          End Featured Work Blocks
          ================================= -->
          
          <!-- ================================
          Start Testimonials Blocks
          ================================= -->
          <div class="testimonialCol">
            <h4 class="smText regular d-block">Testimonials</h4>
            <div class="testimonialSlider">
              <div class="swiper testimonialSwiper">
                <div class="swiper-wrapper">
                  {% for t in testimonials %}
                  {% if t.is_active %}
                  <div class="swiper-slide">
                    <div class="testimonialCard">
                      <div class="row align-items-center">
                        <div class="col-sm-auto">
                          <div class="tImgCol">
                            <img src="{% static 'images/user-thumb.jpg' %}" alt="...">
                          </div>
                        </div>
                        <div class="col-sm">
                          <div class="tContentCol">
                            <h4 class="xsTitle bold">{{t.name}}</h4>
                            <p>{{t.quote}}</p>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  {% endif %}
                  {% endfor %}
                </div>
                <div class="test-swiper-button-next swiper-button-next swiperBtnStyle"></div>
                <div class="test-swiper-button-prev swiper-button-prev swiperBtnStyle"></div>
              </div>
              
            </div>
          </div>
        </div>
      </div>
    </section>
    <!-- ================================
    End Testimonials Blocks
    ================================= -->
    <!-- ================================
    Start Recent Post Blocks
    ================================= -->
    <section>
      <div class="sectionSpaceSm lightBg">
        <div class="container">
          <div class="row pb-3">
            <div class="col">
              <h4 class="smText regular">Recent posts</h4>
            </div>
            <div class="col-auto">
              <a href="{% url 'main:blogs'%}" class="simpleLink">View all</a>
            </div>
          </div>
          <div class="row g-3">
            {% for b in blogs|dictsortreversed:"timestamp"|slice:":2" %}
            {% if b.is_active %}
            <div class="col-lg-6">
              <div class="cardStyle1">
                <h4 class="mdTitle cs1Title"><a href="javascript:void(0)">{{b.name}}</a></h4> 
                <ul class="cardOptionCol">
                  <li>{{b.timestamp}}</li>
                  <li>{{b.author}}</li>
                </ul>
                <p>{{b.body|safe}}</p>
              </div>
            </div>
            {% endif %}
            {% endfor %}
          </div>
        </div>
      </div>
    </section>
<!-- ================================
End Content
================================= -->

{% endblock %}

main/templates/main/portfolio.html
{% extends 'main/base.html' %}
{% load static %}

<!-- ================================
    Start SEO blocks
    ================================= -->
    {% block title %} Portfolio {% endblock %}
    {% block description %}{% endblock %}
    {% block keywords %}{% endblock %}
<!-- ================================
    END SEO blocks
    ================================= -->
 
<!-- ================================
    Start CSS blocks
    ================================= -->
    {% block extends_header %}{% endblock %}
<!-- ================================
    END CSS blocks
    ================================= -->  
 
<!-- ================================
    Start Script blocks
    ================================= -->
    {% block extend_footer %}{% endblock %}
<!-- ================================
    END Script blocks
    ================================= -->  
    
    {% block  content %}
 
 <!-- ================================
    Start Content
    ================================= -->
    <section>
      <div class="innerPageBannerCol">
        <div class="container">
          <div class="row g-4 g-md-3  align-items-center">
            <div class="col-md-6">
              <div class="bannerContent">
                <h1 class="xlTitle pb-md-3">See my recent projects below</h1>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    
    <section>
      <div class="lightBg">
        <div class="container pt-4">
          <div class="row"> <!-- Add a row container -->
            {% for p in portfolios %}
              {% if p.is_active %}
                <div class="col-md-6 pColMain mb-4"> <!-- Use col-md-6 to create two columns, and add mb-4 for space -->
                  <div class="pCol d-flex flex-column">
                    <div class="card rounded flex-grow-1">
                      <img src="{{ p.image.url }}?{{ timestamp }}" alt="{{ p.name }}" class="card-img-top p-3">
                      <div class="card-body">
                        <a href = "{% url 'main:portfolio' slug=p.slug %}"><h5 class="card-title">{{ p.name }}</h5></a>
                      </div>
                    </div>
                  </div>
                </div>
              {% endif %}
            {% endfor %}
          </div>
        </div>
      </div>
    </section>
    
    
    
    
    
    
    {% endblock %}
    <!-- ================================
    End Content
    ================================= -->